package com.kundun.graph.io;

import java.util.ArrayList;
import java.util.HashMap;

import org.apache.log4j.Logger;

import com.kundun.graph.main.Config;

public class ReaderShellEdge extends Reader {
	
	private final static Logger LOGGER = Logger.getLogger(ReaderFile.class.getName());
	
	private String edgeId;
	private String nodeFrom;
	private String nodeTo;
	private String edgeLabel;
	
	public ReaderShellEdge(String id, String from, String to, String label) {
		this.edgeId = id;
		this.nodeFrom = from;
		this.nodeTo = to;
		if(label != null) {
			this.edgeLabel = label;
		}
	}

	@Override
	public ArrayList<HashMap<String, String>> read() throws Exception {
		ArrayList<HashMap<String,String>> parsingResult = new ArrayList<HashMap<String,String>>();
		
		HashMap<String, String> e = new HashMap<String, String>();
		e.put("edge", this.edgeId + ", " + this.nodeFrom + "," + this.nodeTo + ", " + this.edgeLabel);
		
		parsingResult.add(e);
		LOGGER.info(Config.ln() + "Creating new edge directly from shell");
		
		return parsingResult;
	}
	

}
