package com.kundun.graph.model;

import java.util.ArrayList;

import org.apache.log4j.Logger;

import com.kundun.graph.main.Config;

public class Edge {	

	private String id;
	private String label;
	private Node nodeFrom;
	private Node nodeTo;
	
	private final static Logger LOGGER = Logger.getLogger(Edge.class.getName());
	
	public Edge(String id, Node from, Node to, String label) {
		
		LOGGER.info(Config.ln() + "Creating new edge '" + id +"' from node " +
		from.getLabel() + " to node " + to.getLabel());

		this.setId(id);
		this.setNodeFrom(from);
		this.setNodeTo(to);
		this.setLabel(label);
	}

	public Node getNodeFrom() {
		return nodeFrom;
	}

	public void setNodeFrom(Node nodeFrom) {
		this.nodeFrom = nodeFrom;
	}

	public Node getNodeTo() {
		return nodeTo;
	}

	public void setNodeTo(Node nodeTo) {
		this.nodeTo = nodeTo;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
	
	/**
	 * Check uniqueness of Edge ID
	 * 
	 * @param list
	 * @param id
	 * @param label
	 * @return
	 * @throws Exception
	 */
	public static Edge checkAndCreateUniqueEdge(ArrayList<Edge> list, String id, Node from, Node to, String label) throws Exception {
		
		for(Edge e : list) {
			if ((e.getId()).equals(id)) {
				LOGGER.info(Config.ln() + "Edge with ID: " + id + " is NOT unique - creating failed.");
				throw new Exception();
					
			}
		}
		LOGGER.info(Config.ln() + "Edge with ID: " + id + " is unique - creating succesfull.");
		return new Edge(id, from, to, label);
	}
}
