package com.kundun.graph.model;

import java.util.ArrayList;

import org.apache.log4j.Logger;

import com.kundun.graph.main.Config;

public class IndirectGraph extends Graph {
	
	private final static Logger LOGGER = Logger.getLogger(IndirectGraph.class.getName());
	
	/**
	 * Factory method with construction arguments
	 * 
	 * @param label
	 * @param nodes
	 * @param edges
	 * @return Graph
	 */
	@Override
	protected Graph createGraph(String id, String label, ArrayList<Node> nodes, ArrayList<Edge> edges) {
		
		return new IndirectGraph(id, label, nodes, edges);
	}
	
	private IndirectGraph(String id, String label, ArrayList<Node> nodes, ArrayList<Edge> edges) {
		
		LOGGER.info(Config.ln() + "Creating new graph: '" + id + "'");
		
		this.setId(id);
		this.setLabel(label);
		this.setNodes(nodes);
		this.setEdges(edges);
		this.saved = false;
	}

	@Override
	protected Graph createGraph(String id, String label) {
		return new IndirectGraph(id, label);
	}
	
	public IndirectGraph(String id, String label) {
		
		LOGGER.info(Config.ln() + "Creating new graph: '" + id + "'");
		
		this.setId(id);
		this.setLabel(label);
		this.saved = false;
	}
}
